// ̃vÔƂSolid񂪑ꐢOSASK̂߂ɍĂꂽ̂ł.
// 썇GāAȂǂg킹ĂĂ܂.
// ɐ[ӂ܂.

#include <math.h>

typedef struct AppCube_ {
	Kps *ps;
	AppInf0 *ai;
	////
	int win;
	float theta_x, theta_y, theta_z;
} AppCube;

#define PI			3.14159265358979324F
#define	Deg2Rad		(PI / 180.0F)

/* IuWFNǵAЂƂ̏dS */
/* IuWFNǵAőMAX_POINTS̓_ */
/* IuWFNǵAőMAX_POLYGONS̃|S */

/* |ŚAЂƂ̏dS */
/* |ŚAőMAX_VERTICES̒_ */

#define	MAX_POINTS		8
#define	MAX_POLYGONS	6
#define	MAX_VERTICES	4

#define	WIDTH	160		/* ʂ̂w̑傫 */
#define	HEIGHT	160		/*		 x̑傫 */

struct POINT3D {
	float x, y, z;
};

struct POINT2D {
	int x, y;
};

struct VERTEX {
	struct POINT3D p3d;
	struct POINT2D p2d; /* ͎ */
};

struct POLYGON {
	int vertices; /* _ */
	int color;
	float center_z;
	struct VERTEX *vertex[MAX_VERTICES]; /* En */
};

struct OBJECT {
	int polygons; /* |S */
	int vertices; /* _ */
	float center_z;
	struct VERTEX vertex[MAX_POINTS];
	struct POLYGON polygon[MAX_POLYGONS];
};

struct ZSORT {
	float z;
	void *p;
};

struct SCREEN {
	float a, b; /* POINT3DPOINT2Dɕϊ邽߂̌W */
	int x0, y0;
	int x_vsize, x_bsize, y_vsize; /* `͈͎wp */
	int fillbuf[2][HEIGHT];
};

void draw_object(struct OBJECT *obj, struct SCREEN *scrn);
void draw_polygon(struct POLYGON *polygon, struct SCREEN *scrn);
void sort_z(int n, struct ZSORT *buf);

/* main()͕̂1̏ꍇlĂȂA
	̂̕ɑΉ鎖͑債ēȂƎv */

int AppCube_ph0(void *w_, void *np)
{
	(void) np;
	AppCube *w = w_;
	kps = w->ps;
	w->theta_x = 0.0F;
	w->theta_y = 0.0F;
	w->theta_z = 0.0F;

	w->win = bla_openWin(WIDTH, HEIGHT, "cube", (w->ai - ai1.ai0) | w->ai->ls << 8);
	((AppWork0 *) w)->ai->win = w->win;
	return 1;
}

bla_Window *win;
int *buf;

int AppCube_ph1(void *w_, void *np)
{
	(void) np;
	AppCube *w = w_;
	kps = w->ps;

	static struct POINT3D vertex[] = {
		{  100.0F,  100.0F,  100.0F }, {  100.0F,  100.0F, -100.0F },
		{  100.0F, -100.0F,  100.0F }, {  100.0F, -100.0F, -100.0F },
		{ -100.0F,  100.0F,  100.0F }, { -100.0F,  100.0F, -100.0F },
		{ -100.0F, -100.0F,  100.0F }, { -100.0F, -100.0F, -100.0F }
	};
	static unsigned char square[6][4] = {
		{ 0, 4, 6, 2 }, { 1, 3, 7, 5 }, /* En */
		{ 0, 2, 3, 1 }, { 0, 1, 5, 4 },
		{ 4, 5, 7, 6 }, { 6, 7, 3, 2 }
	};
	struct OBJECT cube;
	struct SCREEN scrn;
	struct POLYGON *polygon;
	int	i, j;

	cube.polygons = 6; /* |S */
	cube.vertices = 8; /* _ */
	for (i = 0; i < cube.polygons; i++) {
		static int col[] = { 0xff0000, 0x00ff00, 0xffff00, 0x0000ff, 0xff00ff, 0x00ffff };
		polygon = &cube.polygon[i];
		polygon->vertices = 4; /* _ */
		polygon->color = col[i];
		for (j = 0; j < polygon->vertices; j++)
			polygon->vertex[j] = &cube.vertex[square[i][j]];
	}

	scrn.a = 150.0F;
	scrn.b = 400.0F;
	scrn.x0 = WIDTH / 2;
	scrn.y0 = HEIGHT / 2;
	scrn.x_vsize = scrn.x_bsize = WIDTH;
	scrn.y_vsize = HEIGHT;

	float theta_x = w->theta_x;
	float theta_y = w->theta_y;
	float theta_z = w->theta_z;

		float xa, xp, ya, yp, za, zp;
		float xt, yt, zt;
		theta_x += 1.0F * Deg2Rad;
		if (theta_x >= 2.0F * PI)
			theta_x -= 2.0F * PI;
		theta_y += 1.5F * Deg2Rad;
		if (theta_y >= 2.0F * PI)
			theta_y -= 2.0F * PI;
		theta_z += 2.0F * Deg2Rad;
		if (theta_z >= 2.0F * PI)
			theta_z -= 2.0F * PI;
		xp = cos(theta_x); xa = sin(theta_x);
		yp = cos(theta_y); ya = sin(theta_y);
		zp = cos(theta_z); za = sin(theta_z);
		for (i = 0; i < cube.vertices; i++) {
			struct POINT3D *v = &vertex[i], *p = &cube.vertex[i].p3d;
			zt   = xp * v->z + xa * v->y; yt   = xp * v->y - xa * v->z;
			xt   = yp * v->x + ya * zt;   p->z = yp * zt   - ya * v->x;
			p->x = zp * xt   - za * yt;   p->y = zp * yt   + za * xt;
		}
		for (i = 0; i < cube.polygons; i++) {
			float center_z = 0.0F;
			polygon = &cube.polygon[i];
			for (j = 0; j < polygon->vertices; j++)
				center_z += polygon->vertex[j]->p3d.z;
			polygon->center_z = center_z / polygon->vertices;
		}

	win = kps_p(kps, w->win);
	buf = bla_getBuf(win);

		bla_fillRect(win, buf, WIDTH, HEIGHT, 0, 0, 0x000000);
		draw_object(&cube, &scrn);
		bla_flushAll(win);

	w->theta_x = theta_x;
	w->theta_y = theta_y;
	w->theta_z = theta_z;

	appWait0(w->ai, 50);
	return 1 | 0x80000000;
}

void draw_object(struct OBJECT *obj, struct SCREEN *scrn)
{
	int i, j;
	struct ZSORT sortbuf[MAX_POLYGONS];

	/* 3_W2e */
	for (i = 0; i < obj->vertices; i++) {
		float t = scrn->a / (scrn->b + obj->vertex[i].p3d.z);
		obj->vertex[i].p2d.x = scrn->x0 + (int) (obj->vertex[i].p3d.x * t);
		obj->vertex[i].p2d.y = scrn->y0 + (int) (obj->vertex[i].p3d.y * t);
	}

	/* |S`揇\[g */
	for (i = 0; i < obj->polygons; i++) {
		sortbuf[i].z = obj->polygon[i].center_z;
		sortbuf[i].p = &obj->polygon[i];
	}
	sort_z(obj->polygons, sortbuf); /* z̒l̑傫̂Oɗ */

	/* |S`惋[v */
	for (i = 0; i < obj->polygons; i++) {
		struct POLYGON *polygon = sortbuf[i].p;
	//	struct POINT3D v[3], e[2];
		struct { float x, y; } v[3], e[2];

		/* ŏ3_3W𒊏o */
		for (j = 0; j < 3; j++) {
			v[j].x = polygon->vertex[j]->p3d.x;
			v[j].y = polygon->vertex[j]->p3d.y;
		//	v[j].z = polygon->vertex[j]->p3d.z;
		}

		/* 3_A2̕ӃxNgZo */
		e[0].x = v[1].x - v[0].x;
		e[0].y = v[1].y - v[0].y;
	//	e[0].z = v[1].z - v[0].z;
		e[1].x = v[2].x - v[1].x;
		e[1].y = v[2].y - v[1].y;
	//	e[1].z = v[2].z - v[1].z;

		/* ӃxNg̊OςgāA@߂ */
		if (e[0].x * e[1].y - e[0].y * e[1].x <= 0.0F) {
			/* |S̖@xNgz͕ ==  */
			draw_polygon(polygon, scrn);
		}
	}
}

void sort_z(int n, struct ZSORT *buf)
/* IuWFNg̃\[gɂgėp^ */
{
	int i, j;
	for (i = 1; i < n; i++) {
		/* buf[i - 1].z`buf[n].z܂ł̍őlT */
		int i1 = i - 1, max_i = i1;
		float max = buf[i1].z;
		for (j = i; j < n; j++) {
			if (max < buf[j].z) {
				max = buf[j].z;
				max_i = j;
			}
		}
		if (i1 != max_i) {
			/*  */
			struct ZSORT tmp = buf[i1];
			buf[i1] = buf[max_i];
			buf[max_i] = tmp;
		}
	}
}

void draw_polygon(struct POLYGON *polygon, struct SCREEN *scrn)
{
	int i, y_min = 99999, y_max = -1, *fillbuf;
	struct POINT2D p0, p1;
	int x, dx;
	int y;

	/* yĂԂ[0]ցByĂԂ[1]ցB */
	p0 = polygon->vertex[polygon->vertices - 1]->p2d;
	for (i = 0; i < polygon->vertices; i++, p0 = p1) {
		int y0, y1;
		p1 = polygon->vertex[i]->p2d;
		if (p1.y < y_min)
			y_min = p1.y;
		if (p1.y > y_max)
			y_max = p1.y;
		if (p0.y != p1.y) {
			if (p0.y < p1.y) {
				fillbuf = scrn->fillbuf[0];
				y0 = p0.y;
				y1 = p1.y;
				dx = p1.x - p0.x;
				x = p0.x;
			} else {
				fillbuf = scrn->fillbuf[1];
				y0 = p1.y;
				y1 = p0.y;
				dx = p0.x - p1.x;
				x = p1.x;
			}
			x <<= 16;
			dx <<= 16;
			dx /= y1 - y0;
			if (dx >= 0)
				x += 0x8000;
			else
				x -= 0x8000;
			/* NbsOȂx̒li[ */
			if (0 <= y0 && y1 < scrn->y_vsize) {
				/* NbsOsp̍[` */
				for (y = y0; y <= y1; y++, x += dx)
					fillbuf[y] = x >> 16;
			} else {
				/* ̕@͂܂茫Ȃ */
				for (y = y0; y <= y1; y++, x += dx) {
					if (0 <= y && y < scrn->y_vsize) /* NbsO */
						fillbuf[y] = x >> 16;
				}
			}
		}
	}

	/* fillbufQƂēhԂ */
	if (y_min < 0)
		y_min = 0;
	if (y_max >= scrn->y_vsize)
		y_max = scrn->y_vsize - 1;
	for (y = y_min; y <= y_max; y++) {
		p0.x = scrn->fillbuf[0][y];
		p1.x = scrn->fillbuf[1][y];
		if (p0.x <= p1.x)
			bla_fillRect(win, buf, p1.x - p0.x + 1, 1, p0.x, y, polygon->color);
		else
			bla_fillRect(win, buf, p0.x - p1.x + 1, 1, p1.x, y, polygon->color);
	}
}

AppFunc AppCube_f[2] = { AppCube_ph0, AppCube_ph1 };

void stAppCube(AppInf0 *ai, unsigned char *inp)
{
	(void) inp;
	appInf0_0(ai, sizeof (AppCube), AppCube_f);
}
