#define aMAX 447
#define STEP (14.0 / 0x100000)
#define DN 4

typedef struct AppMandel_ {
	Kps *ps;
	AppInf0 *ai;
	////
	int x, y;
	int win;
} AppMandel;

int AppMandel_ph0(void *w_, void *np)
{
	(void) np;
	AppMandel *w = w_;
	kps = w->ps;
	w->x = 0;
	w->y = 0;
	w->win = bla_openWin(512, 384, "mandel", (w->ai - ai1.ai0) | w->ai->ls << 8);
	((AppWork0 *) w)->ai->win = w->win;
	return 1;
}

int AppMandel_ph1(void *w_, void *np)
{
	(void) np;
	AppMandel *w = w_;
	kps = w->ps;
	int n, sx, sy, sn, c, x = w->x, y = w->y;
	double zx, zy, cx, cy, xx, yy, tx, ty;
	sn = 0;
	for (sx = 0; sx < DN; sx++) {
		cx = (double) 0x4750 / 0x10000 + (x * DN + sx) * (STEP / DN);
		for (sy = 0; sy < DN; sy++) {
			cy = (double) -0x1e8 / 0x10000 - (y * DN + sy) * (STEP / DN);
			zx = zy = 0;
			for (n = 0; n < aMAX; n++) {
				xx = zx * zx;
				yy = zy * zy;
				if (xx + yy > 4) break;
				tx = xx - yy;
				ty = zx * zy * 2;
				zx = tx + cx;
				zy = ty + cy;
			}
			sn += n;
		}
	}
	n = sn / (DN * DN);
	c = 0;
	if (n < 256)
		c = bla_rgb(n, 0, 0);
	else if (n < aMAX)
		c = bla_rgb(255, n - 255, 0);
	bla_Window *win = kps_p(kps, w->win);
	bla_setPix(win, bla_getBuf(win), x, y, c);
//	if (bla_inkey(win) != 0) return -1;
	w->x++;
	if (w->x >= 512) {
		bla_leapFlushAll(win, 300);
		w->x = 0;
		w->y++;
		if (w->y >= 384) {
			bla_flushAll(win);
			return 2;
		}
	}
	return 1;
}

int AppMandel_ph2(void *w_, void *np)
{
	(void) np;
	AppMandel *w = w_;
//	kps = w->ps;
//	bla_Window *win = kps_p(kps, w->win);
//	if (bla_inkey(win) != 0) return -1;
//	appWait1(w->ai, 32*0+);
w->ai->slp = 0x7fffffffffffffffLL;
	return 2 | 0x80000000;
}

AppFunc AppMandel_f[3] = { AppMandel_ph0, AppMandel_ph1, AppMandel_ph2 };

void stAppMandel(AppInf0 *ai, unsigned char *inp)
{
	(void) inp;
	appInf0_0(ai, sizeof (AppMandel), AppMandel_f);
}
