typedef struct AppMonitor_ {
	Kps *ps;
	AppInf0 *ai;
	////
	int i, ls;
	int win;
} AppMonitor;

int AppMonitor_ph0(void *w_, void *np)
{
	(void) np;
	AppMonitor *w = w_;
	kps = w->ps;
	w->win = bla_openWin(20 * 16, 4 * 16, "monitor", (w->ai - ai1.ai0) | w->ai->ls << 8);
	bla_Window *win = kps_p(kps, w->win);
	((AppWork0 *) w)->ai->win = w->win;
	bla_fillRect(win, bla_getBuf(win), 20 * 16, 4 * 16, 0, 0, 0xffffff);
	if (ai1.ai0[w->i].ls == w->ls) {
		char s[40];
		sprintf(s, "#%d %s", w->i, ai1.ai0[w->i].nam);
		bla_drawStr(win, bla_getBuf(win), 0, 0, 0x000000, 0xffffff, s);
	}
	return 1;
}

int AppMonitor_ph1(void *w_, void *np)
{
	char s[40];
	(void) np;
	AppMonitor *w = w_;
	kps = w->ps;
	bla_Window *win = kps_p(kps, w->win);
	if (ai1.ai0[w->i].ls != w->ls) {
		w->ls = -1;
		bla_drawStr(win, bla_getBuf(win), 12 * 16, 0, 0x000000, 0xffffff, "(lost)");
	} else {
		if (ai1.ai0[w->i].f == AppCount0_f) {
			AppCount0 *v = ai1.ai0[w->i].w;
			sprintf(s, "c = %010d  ", ((unsigned int) v->c) % 2000);
			bla_drawStr(win, bla_getBuf(win), 0, 1 * 16, 0x000000, 0xffffff, s);
		}
		if (ai1.ai0[w->i].f == AppCount1_f) {
			AppCount1 *v = ai1.ai0[w->i].w;
			sprintf(s, "c = %012lld  ", ((unsigned long long) v->c) % 1000000000000LL);
			bla_drawStr(win, bla_getBuf(win), 0, 1 * 16, 0x000000, 0xffffff, s);
		}
		if (ai1.ai0[w->i].f == AppCount2_f) {
			AppCount2 *v = ai1.ai0[w->i].w;
			sprintf(s, "c = %012lld  ", ((unsigned long long) v->c) % 1000000000000LL);
			bla_drawStr(win, bla_getBuf(win), 0, 1 * 16, 0x000000, 0xffffff, s);
		}
		if (ai1.ai0[w->i].f == AppCube_f) {
			AppCube *v = ai1.ai0[w->i].w;
			if (v->theta_x < 0.0 || v->theta_x > 9.99) v->theta_x = 0.0;
			if (v->theta_y < 0.0 || v->theta_y > 9.99) v->theta_y = 0.0;
			if (v->theta_z < 0.0 || v->theta_z > 9.99) v->theta_z = 0.0;
			sprintf(s, "theta_x = %f  ", v->theta_x);
			bla_drawStr(win, bla_getBuf(win), 0, 1 * 16, 0x000000, 0xffffff, s);
			sprintf(s, "theta_y = %f  ", v->theta_y);
			bla_drawStr(win, bla_getBuf(win), 0, 2 * 16, 0x000000, 0xffffff, s);
			sprintf(s, "theta_z = %f  ", v->theta_z);
			bla_drawStr(win, bla_getBuf(win), 0, 3 * 16, 0x000000, 0xffffff, s);
		}
		if (ai1.ai0[w->i].f == AppMandel_f) {
			AppMandel *v = ai1.ai0[w->i].w;
			sprintf(s, "x = %04d    y = %04d  ", v->x & 8191, v->y & 8191);
			bla_drawStr(win, bla_getBuf(win), 0, 1 * 16, 0x000000, 0xffffff, s);
		}
		if (ai1.ai0[w->i].f == AppInvader_f) {
			AppInvader *v = ai1.ai0[w->i].w;
			sprintf(s, "fx = %04d    ix = %04d    iy = %04d  ", v->fx & 8191, v->ix & 8191, v->iy & 8191);
			bla_drawStr(win, bla_getBuf(win), 0, 1 * 16, 0x000000, 0xffffff, s);
			sprintf(s, "point = %04d lx = %04d    ly = %04d  ", v->point & 8191, v->lx & 8191, v->ly & 8191);
			bla_drawStr(win, bla_getBuf(win), 0, 2 * 16, 0x000000, 0xffffff, s);
			sprintf(s, "mwait0 = %04d  score = %08d  ", v->mwait0 & 8191, v->score & (8192 * 8192 - 1));
			bla_drawStr(win, bla_getBuf(win), 0, 3 * 16, 0x000000, 0xffffff, s);
		}
	}
	bla_flushAll(win);
	appWait0(w->ai, 128);
	return 1 | 0x80000000;
}

AppFunc AppMonitor_f[2] = { AppMonitor_ph0, AppMonitor_ph1 };

void stAppMonitor(AppInf0 *ai, unsigned char *inp)
{
	(void) inp;	
	int i = inp[6] - '0'; // "run 6 ?"
	appInf0_0(ai, sizeof (AppMonitor), AppMonitor_f);
	AppMonitor *w = ai->w;
	w->i = 0;
	w->ls = -1;
	if (0 <= i && i < ai1.ipol.n1 && ai1.ai0[i].flg != 0) {
		w->i = i;
		w->ls = ai1.ai0[i].ls;
	}
}
