#include <stdio.h>

void kerr(const char *f, ...);

///

#define KPPOL0_USE 1

typedef struct Kppol0_ {
    int s, n;
    void *p;
    #if (KPPOL0_USE != 0)
        int a, u;
    #endif
} Kppol0;

void kppol0_0(Kppol0 *w, int s);
void kppol0_f(Kppol0 *w, void *p);
void *kppol0_a(Kppol0 *w);

////

#define KMLC0_CACHE 1

typedef struct Kmlc0_ {
    int n, *t;
    Kppol0 *p;
    #if (KMLC0_CACHE != 0)
        int cs, ci;
    #endif
} Kmlc0;

void kmlc0_0();
int kmlc0_i(int s);
void *kmlc0_a0(int i);
void kmlc0_f0(void *p, int i);
void *kmlc0_a1(int s);
void kmlc0_f1(void *p, int s);
int kmlc0_s1(int s);
void *kmlc0_r1(void *p, int s0, int s1);
void kmlc0_rpt(FILE *fp);

////

typedef struct Kipol0_ {
	int u, n0, n1, s1;
} Kipol0;

void kipol0_0(Kipol0 *w, int u, int s, int i0);
int kipol0_e(Kipol0 *w);
int kipol0_a(Kipol0 *w, void *p);
void kipol0_f(Kipol0 *w, void *p, int i);

////

typedef struct Kps_t_ {
    void *p;
	unsigned char ls, s1i, flg[2];
	int s, t;
} Kps_t;

typedef struct Kps_ {
	Kps_t *t;
	Kipol0 ipol;
} Kps;

extern Kps *kps;

void kps_0(Kps *w, int s, int i0);
int kps_a0(Kps *w);
void kps_f0(Kps *w, int i);
int kps_a1(Kps *w);
void kps_f1(Kps *w, int is);
int kps_a2(Kps *w, int s, int t);
void kps_f2(Kps *w, int is);
int kps_t(Kps *w, int is);
void *kps_p(Kps *w, int is);

////

//long long clkusec(void);

long long ltmusec0(void);
long long ltmusec1(void);


