#include "bla.h"
#include <string.h>

typedef int (*AppFunc)(void *, void *);

typedef struct AppInf0_ {
	int prv, nxt, ph;
	long long run, slp, w0, t0, s0, st;
	unsigned int max, unt;
	void *w;
	AppFunc *f;
	const char *nam;
	int win; // pstype`FbN悤ɂȂ΁A͂ȂȂ.
	unsigned char lv, ls, lv0, flg;
} AppInf0;

long long systim;

typedef struct AppInf1_ {
	AppInf0 ai0[16];
	Kipol0 ipol;
	int h[3], n[3];
} AppInf1;

typedef struct AppWork0_ {
	Kps *ps;
	AppInf0 *ai;
} AppWork0;

AppInf1 ai1;

void appInf0_0(AppInf0 *ai, int ws, AppFunc *f /* , const char *nam */)
{
	Kps *ps = kmlc0_a1(sizeof (Kps));
	kps_0(ps, 16, 0);	// pspsɓo^Ȃ(₱Ȃ̂).
	kps_a2(ps, ws, -1);
	ai->ph = 0;
	ai->run = 0LL;
	ai->slp = 0LL;
	ai->st = 0LL;
	ai->w0 = ai->t0 = ai->s0 = ltmusec1();
	ai->max = 0;
	ai->unt = 4000;
	ai->w = ps->t[0].p;
	ai->f = f;
//	ai->nam = nam;
	ai->win = -1;
	((AppWork0 *) ai->w)->ps = ps;
	((AppWork0 *) ai->w)->ai = ai;
}

void procAdd(int i, int lv)
{
	int p, n;
	if (ai1.n[lv] == 0) {
		ai1.ai0[i].prv = i;
		ai1.ai0[i].nxt = i;
	} else {
		n = ai1.h[lv];
		p = ai1.ai0[n].prv;
		ai1.ai0[i].prv = p;
		ai1.ai0[i].nxt = n;
		ai1.ai0[p].nxt = i;
		ai1.ai0[n].prv = i;
	}
	ai1.n[lv]++;
	ai1.h[lv] = i;
	ai1.ai0[i].lv = lv;
}

void procRmv(int i, int lv)
{
	int p, n;
	p = ai1.ai0[i].prv;
	n = ai1.ai0[i].nxt;
	ai1.ai0[p].nxt = n;
	ai1.ai0[n].prv = p;
	ai1.n[lv]--;
	if (ai1.h[lv] == i)
		ai1.h[lv] = n;
}

void procChg(int i, int lv, long long t)
{
	AppInf0 *a = ai1.ai0;
	if (lv != a[i].lv) {
		if (a[i].lv == 0)
			a[i].s0 = t;	// a痎Ƃ.
		procRmv(i, a[i].lv);
		if (lv == 0)
			a[i].st += t - a[i].s0;	// w/saɏオƂ.
		procAdd(i, lv);
	}
}

void appWait0(AppInf0 *ai, int ms)
{
	ai->w0 = ai->slp = ai->w0 + ms * 1000;
}

void appWaitReset(AppInf0 *ai)
{
	ai->w0 = ltmusec1();
}

void appWait1(AppInf0 *ai, int ms)
{
	ai->w0 = ltmusec1();
	appWait0(ai, ms);
}

void stAppCount0(AppInf0 *ai, unsigned char *inp);
void stAppCount1(AppInf0 *ai, unsigned char *inp);
void stAppMandel(AppInf0 *ai, unsigned char *inp);
void stAppCube(AppInf0 *ai, unsigned char *inp);
void stAppCount2(AppInf0 *ai, unsigned char *inp);
void stAppInvader(AppInf0 *ai, unsigned char *inp);
void stAppMonitor(AppInf0 *ai, unsigned char *inp);

typedef void (*StApp)(AppInf0 *, unsigned char *);

StApp stApp[10] = { stAppCount0, stAppCount1, stAppMandel, stAppCube, stAppCount2, stAppInvader, stAppMonitor, 0, 0, 0 };
const char *appNam[10] = { "counter0", "counter1", "mandel", "cube", "counter2", "invader", "monitor", 0, 0, 0 };

int max999(int i)
{
	if (i > 999999)
		i = 999999;
	return i;
}

#include "apcons.c"
#include "apcount0.c"
#include "apcount1.c"
#include "apmandel.c"
#include "apcube.c"
#include "apcount2.c"
#include "apinvadr.c"
#include "apmonitr.c"

void AppCons_set(int i, const char *n, int v)
{
	AppFunc *f = ai1.ai0[i].f;
	if (f == AppInvader_f) {
		AppInvader *w = ai1.ai0[i].w;
		if (strcmp(n, "score"   ) == 0) w->score    = v;
		if (strcmp(n, "iy"      ) == 0) w->iy       = v;
		if (strcmp(n, "point"   ) == 0) w->point    = v;
		if (strcmp(n, "mwait0"  ) == 0) w->mwait0   = v; // ŏ20.
	}
}

////

int bla_main(int argc, const char *argv)
{
	int i, j, k;
	char s[40];
	(void) argc;
	(void) argv;
	kmlc0_0();
	kipol0_0(&ai1.ipol, sizeof (AppInf0), 16, 1);
	ai1.ai0[0].ls = 0;
	ai1.ai0[0].flg = 1;
	appInf0_0(&ai1.ai0[0], sizeof (AppCons), AppCons_f);
	ai1.ai0[0].nam = "console";
	ai1.n[0] = 0;
	ai1.n[1] = 0;
	ai1.n[2] = 0;
	procAdd(0, 0);
	long long t0 = ltmusec1(), t1, t2, dt, t3;
	for (;;) {
		AppInf0 *ai0 = &ai1.ai0[ai1.h[0]];
		t2 = t0 + ai0->unt;
		t3 = t0;
		if ((ai0->ph & 0x80000000) == 0) {
			do {
				ai0->ph = ai0->f[ai0->ph](ai0->w, 0);
				t1 = ltmusec1();
				systim = 0LL;
				dt = t1 - t3;
				if (dt > 0) {
					unsigned int idt = dt;
					if (ai0->max < idt)
						ai0->max = idt;
				}
				t3 = t1;
			} while (t1 < t2 && (ai0->ph & 0x80000000) == 0);
			ai0->run += t1 - t0 - systim;
			ai0->st += systim;
			t0 = t1;
		}
		ai1.h[0] = ai0->nxt;
		if ((ai0->ph & 0x80000000) != 0) {
			ai0->ph &= 0x7fffffff;
			procRmv(ai0 - ai1.ai0, 0);
			if (ai0->ph == 0x7fffffff) {
				kps = ((AppWork0 *) ai0->w)->ps;
				i = ((AppWork0 *) ai0->w)->ai->win;
				if (i >= 0)
					bla_closeWin(i);
				for (i = 0; i < kps->ipol.n1; i++) {
					if (kps->t[i].s1i >= 0xf0) continue;
					kmlc0_f0(kps->t[i].p, kps->t[i].s1i);
				}
				kmlc0_f1(kps->t, kps->ipol.s1 * sizeof (Kps_t));
				kmlc0_f1(kps, sizeof (Kps));
				ai0->ls++;
				ai0->flg = 0;
				kipol0_f(&ai1.ipol, ai1.ai0, ai0 - ai1.ai0);
				sprintf(s, "#%d process terminated. run=%06d/%06d", ai0 - ai1.ai0, max999(ai0->run / 1000), max999((t0 - ai0->t0 - ai0->st) / 1000));
				cons_puts(s);
				t0 = ltmusec1();
			} else {
				if (ai0->slp == 0x7fffffffffffffffLL)
					procAdd(ai0 - ai1.ai0, 2);
				else
					procAdd(ai0 - ai1.ai0, 1);
				ai0->s0 = t0;
			}
		}
		for (;;) {
			long long min = 0x7fffffffffffffffLL;
			i = ai1.h[1];
			for (j = ai1.n[1]; j > 0; j--) {
				ai0 = &ai1.ai0[i];
				k = ai0->nxt;
				if (ai0->slp <= t0)
					procChg(i, 0, t0);
				if (min > ai0->slp)
					min = ai0->slp;
				i = k;
			}
			if (ai1.n[0] > 0) break;
			min -= t0;
			if (min >= 62000LL)
				bla_wait(63);
			else
				bla_wait(((int) min) / 1000 + 1);
			t0 = ltmusec1();
		}
	}
	return 0;
}

